#include <GL/glew.h>
#include <cassert>

#include "rendering/wrapper/StreamBuffer.h"

StreamBuffer::StreamBuffer(int size, int bytesPerVertex) :
bufferSize(size), offset(size), bytesPerVertex(bytesPerVertex), index(0), buffer(nullptr) {
}

void StreamBuffer::reset(int size) {
    if(offset + size >= bufferSize) {
        offset = 0;
        glBufferData(GL_ARRAY_BUFFER, bufferSize, nullptr, GL_STREAM_DRAW);
    }
    buffer = static_cast<char*> (glMapBufferRange(GL_ARRAY_BUFFER, offset, size, GL_MAP_WRITE_BIT | GL_MAP_UNSYNCHRONIZED_BIT));
    assert(buffer != nullptr);
    index = 0;
}

void StreamBuffer::draw() {
    glUnmapBuffer(GL_ARRAY_BUFFER);
    glDrawArrays(GL_TRIANGLE_STRIP, offset / bytesPerVertex, index / bytesPerVertex);
    offset += index;
}